#include <nuon/bios.h>
#include <nuon/dma.h>
#include <nuon/video.h>
#include <nuon/mml2d.h>
#include <nuon/mutil.h>
#include <nuon/msprintf.h>
//#include <stdio.h>

//32 bit color values taken from mml2d.h

#define NTSCWHITE (0xB4808000UL)
#define WHITE (0xEB808000UL)
#define BLACK (0x10808000UL)
#define FIRST_ROW (60UL)
#define LAST_ROW (419UL)
#define NUM_COLORS (2UL)

//Use 32 bit 8-8-8-Alpha full-screen mode
#define SCREEN_WIDTH (720UL)
#define SCREEN_HEIGHT (480UL)

#define MAIN_CHANNEL_WIDTH SCREEN_WIDTH
#define MAIN_CHANNEL_HEIGHT SCREEN_HEIGHT

unsigned long *mainChannelBuffer;
int localSize;

VidDisplay mainDisplay;
VidChannel mainChannel;

void vidsetup(void)
{
  mainChannel.dmaflags = ((MAIN_CHANNEL_WIDTH >> 3) << 16) | ePixDma | eCluster | (4UL<<4);
  mainChannelBuffer =
    (unsigned long *)_MemAlloc((MAIN_CHANNEL_WIDTH * MAIN_CHANNEL_HEIGHT) << 2, 512, kMemSDRAM);

  _VidSetup((void *)mainChannelBuffer,mainChannel.dmaflags, MAIN_CHANNEL_WIDTH, MAIN_CHANNEL_HEIGHT, 0);
}

struct ThreadArgStruct
{
  unsigned int y;
  unsigned int color;
  char *text;
};
 
void ClearScreen(long the_color)
{
  unsigned long x,y,numPixels;

  for(y = 0; y < MAIN_CHANNEL_HEIGHT; y = y + 8)
  {
    for (x = 0; x < MAIN_CHANNEL_WIDTH; x = x + 8)
    {
      _DMABiLinear(mainChannel.dmaflags|DMA_DIRECT_BIT, mainChannelBuffer, (8<<16)|x, (8<<16)|y, (void *)the_color);
    }
  }
}

void DoThread(ThreadArgStruct *arg)
{
  while(1)
  {
    DebugWS(mainChannel.dmaflags,mainChannelBuffer,10,arg->y+0,arg->color,arg->text);
    DebugWS(mainChannel.dmaflags,mainChannelBuffer,10,arg->y+30,arg->color,arg->text);
    DebugWS(mainChannel.dmaflags,mainChannelBuffer,10,arg->y+60,arg->color,arg->text);
    DebugWS(mainChannel.dmaflags,mainChannelBuffer,10,arg->y+90,arg->color,arg->text);
  }
}

#define STACK_SIZE (128UL)
static long thread_stack[STACK_SIZE] __attribute__((aligned(16)));
char text0[128];
char text1[128];

int main(void)
{
  int mpe;
  struct ThreadArgStruct ta0, ta1;

  ta0.y = 20;
  ta0.color = kYellow;
  ta0.text = text0;

  ta1.y = 35;
  ta1.color = kWhite;
  ta1.text = text1;


  vidsetup();

  _MediaShutdownMPE();

   mpe = _MPEAlloc(MPE_HAS_CACHES);

  /* fill with grey */
  ClearScreen(kBlack);

  int y = 0xDEADBEEF;

  text0[0] = '\0';
  text1[0] = '\0';

  msprintf(text0,"mpe%d rules",0);
  msprintf(text1,"%s%d%s","no way... mpe",3," rules");

  if(mpe >= 0)
  {
    _MPERunThread(mpe, DoThread, &ta0, thread_stack+STACK_SIZE);
  }  
  
  DoThread(&ta1);

  return 1;
}
